//+------------------------------------------------------------------+ 
//|   FLI_VOLUME_FORCE_PLOT                                          | 
//|                                                                  | 
//|   Use as ICustom the VF Indicator, BASED on TRO_VOLUME_FORCE     |
//|   Indicator (http://kreslik.com) and plot on main graph arrows   | 
//|   that indicate the direction of the volume force.               | 
//+------------------------------------------------------------------+ 

#property  copyright "Francesco Marasco" 

#property indicator_chart_window
#property indicator_buffers 2

extern color VolumeForceUpColor = DeepSkyBlue;
extern color VolumeForceDnColor  = DeepPink;
extern int SymbolWidth  = 2 ;
extern int MAPeriod = 20;
 
static double BufUp[], BufDn[];
static double B1[], B2[];
string symbol, tChartPeriod, tShortName, short_name;
int    digits, period; 
double point;

double v4[];
 
int init()
  {
  
   period       =  Period() ;    
   symbol       =  Symbol() ;
   digits       =  Digits ;   
   point        =  Point ;

   IndicatorBuffers(2); 
   SetIndexStyle(0,DRAW_ARROW,0,4,VolumeForceUpColor); 
   SetIndexArrow(0, 241); 
   SetIndexBuffer(0,B1); 
   SetIndexStyle(1,DRAW_ARROW,0,4,VolumeForceDnColor); 
   SetIndexBuffer(1,B2); 
   SetIndexArrow(1, 242); 

   short_name = "VFP";
   IndicatorShortName(short_name);

   return(0);
} 

int deinit()
{
   return(0);
} 

int start()
{
   int limit;
   int counted_bars=IndicatorCounted();
   if(counted_bars>0) counted_bars--;
   limit = Bars - counted_bars - 1;

   double tempv,x1,x2,x3;
   for (int i=0;i<limit;i++)
   {
      x1 = iCustom(symbol,period,"VF",false,DeepSkyBlue,DeepPink,DimGray,2,MAPeriod,0,i);
      x2 = iCustom(symbol,period,"VF",false,DeepSkyBlue,DeepPink,DimGray,2,MAPeriod,1,i);
      x3 = iCustom(symbol,period,"VF",false,DeepSkyBlue,DeepPink,DimGray,2,MAPeriod,2,i);

      if ((x1 != EMPTY_VALUE)&&(x1>x3)) B1[i] = iLow(symbol,period,i);
      if ((x2 != EMPTY_VALUE)&&(x2>x3)) B2[i] = iHigh(symbol,period,i);
   }
   
   return(0);
}

