//+------------------------------------------------------------------------+ 
//|   VF                                                                   | 
//|                                                                        | 
//|   Based on TRO_VOLUME_FORCE by TheRumpledOne (TRO) http://kreslik.com  | 
//|   VF introduce just an average to TRO_VOLUME_FORCE                     | 
//|                                                                        | 
//|   If you want the original indicator, go to http://kreslik.com         | 
//+------------------------------------------------------------------------+ 

#property  copyright "Francesco Marasco" 
 

#property indicator_separate_window
#property indicator_buffers 3

extern bool Show.Message = true ; 
 
extern color VolumeForceUpColor = DeepSkyBlue;
extern color VolumeForceDnColor  = DeepPink;
extern color NoSignalColor    = DimGray;

extern int   SymbolWidth  = 2 ;
extern int     MAPeriod = 20;

//+------------------------------------------------------------------+
 
double BufUp[], BufDn[];

string symbol, tChartPeriod,  tShortName , TAG, tObjName06,  short_name, TheMessage;  
int    digits, period, digits2  ; 
double point ;

double  cVOLUME, pVOLUME, O,C,H, L, H1, L1, cRANGE, pRANGE;

bool win, sincebull, sincebear , VolumeForceDn, VolumeForceUp, oneHigh = false , oneLow = false ; 
color TheColor ; 
 
datetime Trigger ; 

double v4[];
 
//+------------------------------------------------------------------+
int init()
  {
  
   period       =  Period() ;    
   symbol       =  Symbol() ;
   digits       =  Digits ;   
   point        =  Point ;
      
      SetIndexBuffer(0,BufUp);
      SetIndexStyle(0,DRAW_HISTOGRAM,0,SymbolWidth,VolumeForceUpColor);
      SetIndexLabel(0,"VolumeForceUp");
      
      SetIndexBuffer(1,BufDn);
      SetIndexStyle(1,DRAW_HISTOGRAM,0,SymbolWidth,VolumeForceDnColor);
      SetIndexLabel(1,"VolumeForceDn");

     
      SetIndexBuffer(2,v4);
      SetIndexStyle(2,DRAW_LINE,0,2,Gold);
      SetIndexLabel(2,"Average("+MAPeriod+")");

      
      TAG = "volforce" ;

      tObjName06 = TAG + "06" ;        

   short_name = "Volume Force " ;
   
   IndicatorShortName(short_name);


   return(0);
  } 
//+------------------------------------------------------------------+
int deinit()
  {

   return(0);
  } 
//+------------------------------------------------------------------+
int start()
{
   win =    WindowFind(short_name);     
   int limit;
   int counted_bars=IndicatorCounted();

   if(counted_bars>0) counted_bars--;
   
   limit = Bars - counted_bars - 1; //Bars-counted_bars;


sincebull = -1 ;
sincebear = -1 ;
double tempv,x1,x2;
   for(int i=limit; i>=0; i--)   
   {
      cVOLUME = iVolume(symbol,period,i); 
        
   
      O = iOpen(symbol,period,i);
      H = iHigh(symbol,period,i);
      L = iLow(symbol,period,i);      
      C = iClose(symbol,period,i);
 
      VolumeForceDn = C < O ;   
      VolumeForceUp = C > O ; 

      while(true)
      {
         if (VolumeForceDn)
         { 
            sincebear = i ; 
            oneLow  = true ; 
            BufDn[i] = (O - C)/point * cVOLUME ;  
            BufUp[i] = EMPTY_VALUE ; 
            TheColor = VolumeForceDnColor ; 
            TheMessage = "Volume Force Down" ;
            break ; 
         }
         
         if (VolumeForceUp)
         { 
            sincebull = i ;   
            oneHigh = true ; 
            BufUp[i] = (C - O)/point * cVOLUME ;  
            BufDn[i] = EMPTY_VALUE ; 
            TheColor = VolumeForceUpColor ; 
            TheMessage = "Volume Force Up"  ;          
            break ; 
         }
         
         TheColor = NoSignalColor ;
         BufUp[i] = EMPTY_VALUE ; BufDn[i] = EMPTY_VALUE ; break ;
 
      } // while
          
  } // for

  
//  if( Sound.Alert ) { DoAlert() ; }
  

   if(  Show.Message ) { DoShowMessage() ; } 

for (i=0;i<limit;i++)
{
   tempv=0;
   for ( int n=i;n<i+MAPeriod;n++ )
   {
      if (BufUp[n] == EMPTY_VALUE) x1 = 0; else x1 = BufUp[n];
      if (BufDn[n] == EMPTY_VALUE) x2 = 0; else x2 = BufDn[n];
      tempv=(x1+x2) + tempv;
   } 
   v4[i] = NormalizeDouble(tempv/MAPeriod,0);
}

 
   WindowRedraw() ;
   
    
//----
   return(0);
}

//+------------------------------------------------------------------+  
void DoShowMessage()
{ 

int yInc = 1 ;

   setObject(TAG+"cur",TheMessage ,50,yInc,TheColor, "Impact", 15);  

   yInc = yInc + 25 ; 
   setObject(TAG+"bull","Force Up" ,50,yInc,VolumeForceUpColor); setObject(TAG+"bull1",sincebull ,11,yInc,VolumeForceUpColor ,"Courier New");

   yInc = yInc + 15 ; 
   setObject(TAG+"bear","Force Dn" ,50,yInc,VolumeForceDnColor); setObject(TAG+"bear1",sincebear ,11,yInc,VolumeForceDnColor ,"Courier New");
       
       
}

//+------------------------------------------------------------------+  

void setObject(string labelName,string text,int x,int y,color theColor, string font = "Courier New",int size=10,int angle=0)
{
 
      
      if (ObjectFind(labelName) == -1)
          {
             ObjectCreate(labelName,OBJ_LABEL,win,0,0);
             ObjectSet(labelName,OBJPROP_CORNER,1);
             if (angle != 0)
                  ObjectSet(labelName,OBJPROP_ANGLE,angle);
          }               
       ObjectSet(labelName,OBJPROP_XDISTANCE,x);
       ObjectSet(labelName,OBJPROP_YDISTANCE,y);
       ObjectSetText(labelName,text,size,font,theColor);
}
  
//+------------------------------------------------------------------+  

